<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="发送结果" prop="sendCode">
        <el-select v-model="queryParams.sendCode" placeholder="请选择发送结果" clearable size="small">
          <el-option v-for="dict in sendCodeOptions" :key="dict.dictValue" :label="dict.dictLabel" :value="dict.dictValue" />
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="success" plain icon="el-icon-edit" size="mini" :disabled="single" @click="handleUpdate" v-hasPermi="['management:warningLog:edit']">修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="danger" plain icon="el-icon-delete" size="mini" :disabled="multiple" @click="handleDelete" v-hasPermi="['management:warningLog:remove']">删除</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" border :data="warningLogList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="预警信息发送日志Id" align="center" prop="sendLogId" />
      <el-table-column label="预警信息Id" align="center" prop="earlyWarningId" />
      <el-table-column label="微信公众号openId" align="center" prop="mpOpenId" />
      <el-table-column label="发送结果" align="center" prop="sendCode" :formatter="sendCodeFormat" />
      <el-table-column label="发送时间" align="center" prop="sendTime" width="180"/>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button size="mini" type="text" icon="el-icon-edit" @click="handleUpdate(scope.row)" v-hasPermi="['management:warningLog:edit']">修改</el-button>
          <el-button size="mini" type="text" icon="el-icon-delete" @click="handleDelete(scope.row)" v-hasPermi="['management:warningLog:remove']">删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNum" :limit.sync="queryParams.pageSize" @pagination="getList" />

    <!-- 添加或修改预警信息发送日志对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="预警信息Id" prop="earlyWarningId"><el-input v-model="form.earlyWarningId" placeholder="请输入预警信息Id" /></el-form-item>
        <el-form-item label="微信公众号openId" prop="mpOpenId"><el-input v-model="form.mpOpenId" placeholder="请输入微信公众号openId" /></el-form-item>
        <el-form-item label="发送结果">
          <el-radio-group v-model="form.sendCode">
            <el-radio v-for="dict in sendCodeOptions" :key="dict.dictValue" :label="dict.dictValue">{{ dict.dictLabel }}</el-radio>
          </el-radio-group>
        </el-form-item>
        <el-form-item label="发送时间" prop="sendTime">
          <el-date-picker clearable size="small" v-model="form.sendTime" type="date" value-format="yyyy-MM-dd" placeholder="选择发送时间"></el-date-picker>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listWarningLog, getWarningLog, delWarningLog, addWarningLog, updateWarningLog, exportWarningLog } from '@/api/management/warningLog';

export default {
  name: 'WarningLog',
  data() {
    return {
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 预警信息发送日志表格数据
      warningLogList: [],
      // 弹出层标题
      title: '',
      // 是否显示弹出层
      open: false,
      // 发送结果字典
      sendCodeOptions: [],
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        sendCode: null,
        orderByColumn: 'sendTime', //排序字段
        isAsc: 'desc' //排序方式
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {}
    };
  },
  created() {
    this.getList();
    this.getDicts('send_code').then(response => {
      this.sendCodeOptions = response.data;
    });
  },
  methods: {
    /** 查询预警信息发送日志列表 */
    getList() {
      this.loading = true;
      listWarningLog(this.queryParams).then(response => {
        this.warningLogList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 发送结果字典翻译
    sendCodeFormat(row, column) {
      return this.selectDictLabel(this.sendCodeOptions, row.sendCode);
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        sendLogId: null,
        earlyWarningId: null,
        mpOpenId: null,
        sendCode: '0',
        sendTime: null
      };
      this.resetForm('form');
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm('queryForm');
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.sendLogId);
      this.single = selection.length !== 1;
      this.multiple = !selection.length;
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = '添加预警信息发送日志';
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const sendLogId = row.sendLogId || this.ids;
      getWarningLog(sendLogId).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = '修改预警信息发送日志';
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs['form'].validate(valid => {
        if (valid) {
          if (this.form.sendLogId != null) {
            updateWarningLog(this.form).then(response => {
              this.msgSuccess('修改成功');
              this.open = false;
              this.getList();
            });
          } else {
            addWarningLog(this.form).then(response => {
              this.msgSuccess('新增成功');
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const sendLogIds = row.sendLogId || this.ids;
      this.$confirm('是否确认删除预警信息发送日志编号为"' + sendLogIds + '"的数据项?', '警告', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      })
        .then(function() {
          return delWarningLog(sendLogIds);
        })
        .then(() => {
          this.getList();
          this.msgSuccess('删除成功');
        })
        .catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有预警信息发送日志数据项?', '警告', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      })
        .then(() => {
          this.exportLoading = true;
          return exportWarningLog(queryParams);
        })
        .then(response => {
          this.download(response.msg);
          this.exportLoading = false;
        })
        .catch(() => {});
    }
  }
};
</script>
